--- old/usr/src/cmd/sgs/nm/common/nm.c	Tue Feb 27 22:54:11 2018
+++ new/usr/src/cmd/sgs/nm/common/nm.c	Tue Feb 27 22:54:11 2018
@@ -25,6 +25,7 @@
  * All Rights Reserved
  *
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2018 Jason King
  */
 
 #include <stdio.h>
@@ -805,15 +806,15 @@
 		if (sym.st_name == 0)
 			buf->name = "";
 		else if (C_flag) {
-			const char *dn;
+			const char *dn = NULL;
 			char *name = (char *)elf_strptr(elf, link, sym.st_name);
+
 			dn = conv_demangle_name(name);
-			if (strcmp(dn, name) == 0) {	/* Not demangled */
-				if (exotic(name)) {
-					name = FormatName(name, d_buf);
-				}
-			} else {  /* name demangled */
+			if (dn != name) {
 				name = FormatName(name, dn);
+				free((void *)dn);
+			} else if (exotic(name)) {
+				name = FormatName(name, d_buf);
 			}
 			buf->name = name;
 		}
